/*
 * This file is part of the Ant Control Language compiler developed by
 * the team "KaNT" during the ICFP 2004 programming contest.
 *
 * ----------------------------------------------------------------------
 * 
 * Copyright (C) 2004  the ICFP 2004 Team "KaNT"
 *
 * Jens Hauke
 * Thomas Moschny
 * Bernhard Haumacher
 * Bjoern-Oliver Hartmann
 *
 * ----------------------------------------------------------------------
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, 
 * MA 02111-1307, USA.
 *
 */

package ant.compiler.asm;

import ant.compiler.asm.Asm.*;

import java.util.ArrayList;


/**
 * Computes addresses for a graph of {@link Asm} statements and places
 * them in a list in address order.
 * 
 * <p>License: GPL</p>
 *
 * @author <a href="http://www.haumacher.de/>">Bernhard Haumacher</a>
 */
public class AddressResolver extends Asm.DFSPreorderVisitor {
    int addr;
    ArrayList commands = new ArrayList();;

    public ArrayList getCommands() {
	return commands;
    }

    public void reset() {
	super.reset();

	this.addr = 0;
	this.commands.clear();
    }

    public void visitAsm(Asm op) {
	if (! visited(op)) {
	    op.addr = addr++;
	    commands.add(op);
	}

	super.visitAsm(op);
    }
}
