/*
 * This file is part of the Ant Control Language compiler developed by
 * the team "KaNT" during the ICFP 2004 programming contest.
 *
 * ----------------------------------------------------------------------
 * 
 * Copyright (C) 2004  the ICFP 2004 Team "KaNT"
 *
 * Jens Hauke
 * Thomas Moschny
 * Bernhard Haumacher
 * Bjoern-Oliver Hartmann
 *
 * ----------------------------------------------------------------------
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, 
 * MA 02111-1307, USA.
 *
 */

package ant.compiler.ast;

/**
 * Constats representing test conditions of the {@link
 * Tree.ConditionTest} statements.
 * 
 * <p>License: GPL</p>
 *
 * @author <a href="http://www.haumacher.de/>">Bernhard Haumacher</a>
 */
public class Condition {
    public final int id;

    private Condition(int id) {
	this.id = id;
    }

    public static final int ID_FRIEND = 0;
    public static final int ID_FOE = 1;
    public static final int ID_FRIEND_WITH_FOOD = 2;
    public static final int ID_FOE_WITH_FOOD = 3;
    public static final int ID_FOOD = 4;
    public static final int ID_ROCK = 5;
    public static final int ID_MARKER_0 = 6;
    public static final int ID_MARKER_1 = 7;
    public static final int ID_MARKER_2 = 8;
    public static final int ID_MARKER_3 = 9;
    public static final int ID_MARKER_4 = 10;
    public static final int ID_MARKER_5 = 11;
    public static final int ID_FOE_MARKER = 12; 
    public static final int ID_HOME = 13;
    public static final int ID_FOE_HOME = 14;

    public static final Condition FRIEND = new Condition(ID_FRIEND);
    public static final Condition FOE = new Condition(ID_FOE);
    public static final Condition FRIEND_WITH_FOOD = new Condition(ID_FRIEND_WITH_FOOD);
    public static final Condition FOE_WITH_FOOD = new Condition(ID_FOE_WITH_FOOD);
    public static final Condition FOOD = new Condition(ID_FOOD);
    public static final Condition ROCK = new Condition(ID_ROCK);
    public static final Condition MARKER_0 = new Condition(ID_MARKER_0);
    public static final Condition MARKER_1 = new Condition(ID_MARKER_1);
    public static final Condition MARKER_2 = new Condition(ID_MARKER_2);
    public static final Condition MARKER_3 = new Condition(ID_MARKER_3);
    public static final Condition MARKER_4 = new Condition(ID_MARKER_4);
    public static final Condition MARKER_5 = new Condition(ID_MARKER_5);
    public static final Condition FOE_MARKER = new Condition(ID_FOE_MARKER);
    public static final Condition HOME = new Condition(ID_HOME);
    public static final Condition FOE_HOME = new Condition(ID_FOE_HOME);
}
