/*
 * This file is part of the Ant Control Language compiler developed by
 * the team "KaNT" during the ICFP 2004 programming contest.
 *
 * ----------------------------------------------------------------------
 * 
 * Copyright (C) 2004  the ICFP 2004 Team "KaNT"
 *
 * Jens Hauke
 * Thomas Moschny
 * Bernhard Haumacher
 * Bjoern-Oliver Hartmann
 *
 * ----------------------------------------------------------------------
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, 
 * MA 02111-1307, USA.
 *
 */

package ant.compiler.ast;

/**
 * Constants representing sense directions. 
 * 
 * <p>License: GPL</p>
 *
 * @author <a href="http://www.haumacher.de/>">Bernhard Haumacher</a>
 */
public class SenseDirection {
    public final int id;

    private SenseDirection(int id) {
	this.id = id;
    }

    public static final int ID_HERE = 0;
    public static final int ID_AHEAD = 1;
    public static final int ID_LEFT_AHEAD = 2;
    public static final int ID_RIGHT_AHEAD = 3;

    public static final SenseDirection HERE = 
	new SenseDirection(ID_HERE);
    public static final SenseDirection AHEAD = 
	new SenseDirection(ID_AHEAD);
    public static final SenseDirection LEFT_AHEAD = 
	new SenseDirection(ID_LEFT_AHEAD);
    public static final SenseDirection RIGHT_AHEAD = 
	new SenseDirection(ID_RIGHT_AHEAD);
}
