package ant.debug;

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

import javax.imageio.ImageIO;


interface Constants{
  
    //marker
    static final int MARKER_RED_0     = 0x00000001;
    static final int MARKER_RED_1     = 0x00000002;
    static final int MARKER_RED_2     = 0x00000004;
    static final int MARKER_RED_3     = 0x00000008;
    static final int MARKER_RED_4     = 0x00000010;
    static final int MARKER_RED_5     = 0x00000020;
    static final int MARKER_BLACK_0   = 0x00000040;
    static final int MARKER_BLACK_1   = 0x00000080;
    static final int MARKER_BLACK_2   = 0x00000100;
    static final int MARKER_BLACK_3   = 0x00000200;
    static final int MARKER_BLACK_4   = 0x00000400;
    static final int MARKER_BLACK_5   = 0x00000800;

    static final int RED_ANT	      = 0x00001000;
    static final int BLACK_ANT	      = 0x00002000;
    static final int WITH_FOOD	      = 0x00004000;

    //the environment  
    static final int FREE             = 0x00000000;
    static final int RED_ANT_HILL     = 0x00008000;
    static final int BLACK_ANT_HILL   = 0x00010000;
    static final int ROCK	      = 0x00020000;

    static final int PIX_LENGTH       = 8;

    //options
    static final int OPTION_MARKER_BIT = 0x00000001;
    static final int OPTION_MARKER_3C = 0x00000002;
    static final int OPTION_MARKER_FM = 0x00000004;
}


class Ant implements Constants{
    public int ID;

    //A number between 0 and 9999
    public int internalState;

    //The Position
    public byte xPos;
    public byte yPos;

    //a nuber between 0 and 5
    public byte direction;

    //RED|BLACK && WITH_FOOD|!WITH_FOOD
    public int state;

    public byte resting;
}

class Marker{
    int xPos;
    int yPos;
    int red;
    int black;
}

class Food{
    int xPos;
    int yPos;
    int howMuch = 0;
}

class Field implements Constants{
      //a number between 0 and something around 500
      public byte food;
      public int state;
}
      
class AntWorld{
    //The world consists of Fields, Ants and Food(food lies on fields)
    public Field[][] field;
    public Ant[] ants;
    
    public AntWorld(int n, int m, int numberOfAnts){
	field = new Field[n][m];
	for(int i=0; i<field.length;i++){
	    for(int j=0;j<field[i].length;j++){
		field[i][j]	= new Field();
	    }
	}
	ants = new Ant[numberOfAnts];
    }
}

class Round{
    public int number;
    public java.util.List ants;
    public java.util.List food;
    public java.util.List marker;
    
    public Round(int number){
	ants = new Vector(182);
	food = new Vector(1000);
	marker = new Vector(1000, 1000);
	this.number = number;
    }
    
}

class MyCanvas extends Canvas implements Constants{
    AntWorld world;
    //    BufferedImage food, free, red_ant_hill, black_ant_hill, rock;
    BufferedImage red_ant_direction0, red_ant_direction1, red_ant_direction2, red_ant_direction3, red_ant_direction4, red_ant_direction5;
    BufferedImage black_ant_direction0, black_ant_direction1, black_ant_direction2, black_ant_direction3, black_ant_direction4, black_ant_direction5;
    BufferedImage red_ant_direction0food, red_ant_direction1food, red_ant_direction2food, 
	red_ant_direction3food, red_ant_direction4food, red_ant_direction5food;
    BufferedImage black_ant_direction0food, black_ant_direction1food, black_ant_direction2food, 
	black_ant_direction3food, black_ant_direction4food, black_ant_direction5food;
    BufferedImage outPutImage;
    Graphics2D g2D;
    AntDebugger master;

    public static BufferedImage getIcon(String name) throws IOException {
	return ImageIO.read(MyCanvas.class.getResourceAsStream("pictures/" + name));
    }

    public MyCanvas(AntWorld world, AntDebugger master) throws Exception{
	this.world = world;
	this.master = master;
	//	food       = getIcon("FOOD.png"));
	//	free       = getIcon("Free.png");;
	//	red_ant_hill = getIcon("RED_ANT_HILL.png");;
	//	black_ant_hill = getIcon("BLACK_ANT_HILL.png");;
	//	rock       = getIcon("Rock.png");;
	red_ant_direction0 = getIcon("RedAntDirection0.png");;
	red_ant_direction1 = getIcon("RedAntDirection1.png");;
	red_ant_direction2 = getIcon("RedAntDirection2.png");;
	red_ant_direction3 = getIcon("RedAntDirection3.png");;
	red_ant_direction4 = getIcon("RedAntDirection4.png");;
	red_ant_direction5 = getIcon("RedAntDirection5.png");;
	black_ant_direction0 = getIcon("BlackAntDirection0.png");;
	black_ant_direction1 = getIcon("BlackAntDirection1.png");;
	black_ant_direction2 = getIcon("BlackAntDirection2.png");;
	black_ant_direction3 = getIcon("BlackAntDirection3.png");;
	black_ant_direction4 = getIcon("BlackAntDirection4.png");;
	black_ant_direction5 = getIcon("BlackAntDirection5.png");;
	red_ant_direction0food = getIcon("RedAntDirection0Food.png");;
	red_ant_direction1food = getIcon("RedAntDirection1Food.png");;
	red_ant_direction2food = getIcon("RedAntDirection2Food.png");;
	red_ant_direction3food = getIcon("RedAntDirection3Food.png");;
	red_ant_direction4food = getIcon("RedAntDirection4Food.png");;
	red_ant_direction5food = getIcon("RedAntDirection5Food.png");;
	black_ant_direction0food = getIcon("BlackAntDirection0Food.png");;
	black_ant_direction1food = getIcon("BlackAntDirection1Food.png");;
	black_ant_direction2food = getIcon("BlackAntDirection2Food.png");;
	black_ant_direction3food = getIcon("BlackAntDirection3Food.png");;
	black_ant_direction4food = getIcon("BlackAntDirection4Food.png");;
	black_ant_direction5food = getIcon("BlackAntDirection5Food.png");;
	outPutImage = new BufferedImage(900,900, BufferedImage.TYPE_INT_RGB);
	g2D         = outPutImage.createGraphics();
	g2D.setColor(Color.WHITE);
	g2D.fillRect(0, 0, 900, 900);
    }

    public void paintBackground(Graphics2D g2D){
	int offset = 0;
	for(int i=0;i<world.field.length;i++){
	    if((i%2) == 1){
		offset = PIX_LENGTH / 2;
	    }else{
		offset = 0;
	    }
	    for(int j=0;j<world.field[i].length;j++){
		if((world.field[i][j].state & RED_ANT_HILL) == RED_ANT_HILL){
		    //		    g2D.drawImage(red_ant_hill, null, j*PIX_LENGTH+offset, i*PIX_LENGTH);
		    g2D.setColor(Color.RED);
		    g2D.fillRect(j*PIX_LENGTH+offset, i*PIX_LENGTH, 8, 8);
		}else
		    if((world.field[i][j].state & BLACK_ANT_HILL) == BLACK_ANT_HILL){
			//g2D.drawImage(black_ant_hill, null, j*PIX_LENGTH+offset, i*PIX_LENGTH);
			g2D.setColor(Color.BLACK);
			g2D.fillRect(j*PIX_LENGTH+offset, i*PIX_LENGTH, 8, 8);
		    }else
			if(world.field[i][j].state == FREE){
			    g2D.setColor(Color.WHITE);
			    g2D.fillRect(j*PIX_LENGTH+offset, i*PIX_LENGTH, 8, 8);
			}else
			    if((world.field[i][j].state & ROCK) == ROCK){
				//g2D.drawImage(rock, null, j*PIX_LENGTH+offset, i*PIX_LENGTH);
				g2D.setColor(Color.LIGHT_GRAY);
				g2D.fillRect(j*PIX_LENGTH+offset, i*PIX_LENGTH, 8, 8);
			    }
		/*		if(world.field[i][j].food > 0){
		//g2D.drawImage(food, null, j*PIX_LENGTH+offset, i*PIX_LENGTH);
		g2D.setColor(Color.CYAN);
		g2D.fillRect(j*PIX_LENGTH+offset, i*PIX_LENGTH, 8, 8);
		}
		*/
	    }
	}
    }

    BufferedImage background;
    Iterator rounds_it;

    public void init(){
	rounds_it = master.rounds.iterator();
    }    
    
    public void showRound(int position){
	int offset = 0;
	Round round = null;
	round = (Round) master.rounds.get(position);

	Iterator marker_it = round.marker.iterator();
	while(marker_it.hasNext()){
	    Marker marker = (Marker) marker_it.next();
	    if((marker.yPos%2) == 1){
		offset = PIX_LENGTH/2;
	    }else{
		offset = 0;
	    }
	    if((world.field[marker.yPos][marker.xPos].state & RED_ANT_HILL) ==  RED_ANT_HILL){
		continue;
	    }
	    if((world.field[marker.yPos][marker.xPos].state & BLACK_ANT_HILL) ==  BLACK_ANT_HILL){
		continue;
	    }
	    boolean redC = false;
	    if(marker.red > 0){
		if((AntDebugger.options & OPTION_MARKER_BIT) == OPTION_MARKER_BIT){
		    //Der Wert der Marke wird in einem sechs-bit-Feld visualisiert.
		    //   0 1
		    //   2 3
		    //   4 5
		    g2D.setColor(Color.ORANGE);
		    g2D.fillRect(marker.xPos*PIX_LENGTH+offset+1, marker.yPos*PIX_LENGTH+1, 3, 1);
		    g2D.setColor(Color.BLACK);
		    if((marker.red & 1) == 1){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+1, marker.yPos*PIX_LENGTH+3, 1, 1);
		    }
		    if((marker.red & 2) == 2){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+3, marker.yPos*PIX_LENGTH+3, 1, 1);
		    }
		    if((marker.red & 4) == 4){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+1, marker.yPos*PIX_LENGTH+5, 1, 1);
		    }
		    if((marker.red & 8) == 8){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+3, marker.yPos*PIX_LENGTH+5, 1, 1);
		    }
		    if((marker.red & 16) == 16){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+1, marker.yPos*PIX_LENGTH+7, 1, 1);
		    }
		    if((marker.red & 32) == 32){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+3, marker.yPos*PIX_LENGTH+7, 1, 1);
		    }
		}else{
		    if((AntDebugger.options & OPTION_MARKER_3C) == OPTION_MARKER_3C){
			switch(marker.red & 7){
			case 1 :
			case 3:
			case 5:
			case 7:{
			    g2D.setColor(Color.ORANGE);
			    break;
			}
			case 2:
			case 6:{
			    g2D.setColor(Color.MAGENTA);
			    break;
			}
			case 4:{
			    g2D.setColor(Color.PINK);
			    break;			    
			}
			default: g2D.setColor(Color.ORANGE);
			}
		    }else{
			g2D.setColor(Color.ORANGE);
		    }
		    g2D.fillRect(marker.xPos*PIX_LENGTH+offset, marker.yPos*PIX_LENGTH, 8, 8);
		}
		if((AntDebugger.options & OPTION_MARKER_FM) == OPTION_MARKER_FM){
		    //		    g2D.setColor(Color.BLUE);
		    //		    g2D.fillRect(marker.xPos*PIX_LENGTH+offset, marker.yPos*PIX_LENGTH, 8, 8);
		    if ((marker.red & 16) == 16) {
			g2D.setColor(Color.BLACK);
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+2, marker.yPos*PIX_LENGTH + 2, 2, 2);
		    }
		}

		redC = true;
	    }
	    if(marker.black > 0){
		if((AntDebugger.options & OPTION_MARKER_BIT) == OPTION_MARKER_BIT){
		    g2D.setColor(Color.BLUE);
		    g2D.fillRect(marker.xPos*PIX_LENGTH+offset+5, marker.yPos*PIX_LENGTH+1, 3, 1);
		    g2D.setColor(Color.BLACK);
		    if((marker.black & 1) == 1){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+5, marker.yPos*PIX_LENGTH+3, 1, 1);
		    }
		    if((marker.black & 2) == 2){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+7, marker.yPos*PIX_LENGTH+3, 1, 1);
		    }
		    if((marker.black & 4) == 4){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+5, marker.yPos*PIX_LENGTH+5, 1, 1);
		    }
		    if((marker.black & 8) == 8){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+7, marker.yPos*PIX_LENGTH+5, 1, 1);
		    }
		    if((marker.black & 16) == 16){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+5, marker.yPos*PIX_LENGTH+7, 1, 1);
		    }
		    if((marker.black & 32) == 32){
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+7, marker.yPos*PIX_LENGTH+7, 1, 1);
		    }
		}else{
		    if((AntDebugger.options & OPTION_MARKER_3C) == OPTION_MARKER_3C){
			switch(marker.black & 7){
			case 1:
			case 3:
			case 5:
			case 7:{
			    g2D.setColor(Color.BLUE);
			    break;
			}
			case 2:
			case 6:{
			    g2D.setColor(Color.GREEN);
			    break;
			}
			case 4:{
			    g2D.setColor(Color.YELLOW);
			    break;			    
			}
			default: g2D.setColor(Color.BLUE);
			}			
			//			g2D.fillRect(marker.xPos*PIX_LENGTH+offset, marker.yPos*PIX_LENGTH, 8, 8);
		    }else{
			g2D.setColor(Color.BLUE);
		    }
		    if(redC){
			g2D.setColor(Color.BLUE);
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+4, marker.yPos*PIX_LENGTH, 4, 8);
		    }else{
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset, marker.yPos*PIX_LENGTH, 8, 8);
		    }	       
		}	
		if((AntDebugger.options & OPTION_MARKER_FM) == OPTION_MARKER_FM){
		    if ((marker.black & 16) == 16) {
			g2D.setColor(Color.BLACK);
			g2D.fillRect(marker.xPos*PIX_LENGTH+offset+6, marker.yPos*PIX_LENGTH + 2, 2, 2);
		    }
		}
	    }
	}

	Iterator food_it = round.food.iterator();
	while(food_it.hasNext()){
	    Food food = (Food) food_it.next();
	    if((food.yPos%2) == 1){
		offset = PIX_LENGTH/2;
	    }else{
		offset = 0;
	    }
	    if(food.howMuch > 0){
		int groesse = food.howMuch;
		if(food.howMuch > 8){
		    groesse = 8;
		}
		g2D.setColor(Color.CYAN);
		g2D.fillRect(food.xPos*PIX_LENGTH+offset, food.yPos*PIX_LENGTH, groesse, groesse);
	    }
	}

	Iterator ants_it = round.ants.iterator();
	while(ants_it.hasNext()){
	    Ant ant = (Ant) ants_it.next();
	    if((ant.yPos%2) == 1){
		offset = PIX_LENGTH/2;
	    }else{
		offset = 0;
	    }
	    if((ant.state & RED_ANT) == RED_ANT){
		if((ant.state & WITH_FOOD) == WITH_FOOD){
		    switch(ant.direction){
		    case 0: g2D.drawImage(red_ant_direction0food, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 1: g2D.drawImage(red_ant_direction1food, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 2: g2D.drawImage(red_ant_direction2food, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 3: g2D.drawImage(red_ant_direction3food, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 4: g2D.drawImage(red_ant_direction4food, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 5: g2D.drawImage(red_ant_direction5food, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    }
		}else{
		    switch(ant.direction){
		    case 0: g2D.drawImage(red_ant_direction0, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 1: g2D.drawImage(red_ant_direction1, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 2: g2D.drawImage(red_ant_direction2, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 3: g2D.drawImage(red_ant_direction3, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 4: g2D.drawImage(red_ant_direction4, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 5: g2D.drawImage(red_ant_direction5, null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    }
		}
	    }else{
		if((ant.state & WITH_FOOD) == WITH_FOOD){
		    switch(ant.direction){
		    case 0: g2D.drawImage(black_ant_direction0food,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 1: g2D.drawImage(black_ant_direction1food,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 2: g2D.drawImage(black_ant_direction2food,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 3: g2D.drawImage(black_ant_direction3food,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 4: g2D.drawImage(black_ant_direction4food,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 5: g2D.drawImage(black_ant_direction5food,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    }
		}else{
		    switch(ant.direction){
		    case 0: g2D.drawImage(black_ant_direction0,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 1: g2D.drawImage(black_ant_direction1,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 2: g2D.drawImage(black_ant_direction2,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 3: g2D.drawImage(black_ant_direction3,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 4: g2D.drawImage(black_ant_direction4,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    case 5: g2D.drawImage(black_ant_direction5,null, ant.xPos*PIX_LENGTH+offset, ant.yPos*PIX_LENGTH); break;
		    }
		}
	    }
	}
    }


    public void update(Graphics g){
	paint(g);
    }

    int lastRound = -1;

    public void paint(Graphics g){
	Graphics2D g2D = outPutImage.createGraphics();

	paintBackground((Graphics2D) g2D);
	int maxRound = master.rounds.size();
	boolean hasNext;

	    if(lastRound < maxRound-1){
		if(master.back){
		    lastRound--;
		    if(lastRound < 0){
			lastRound = 0;
			hasNext = false;
		    }else{
			hasNext = true;
		    }
		}else{
		    lastRound++;
		    hasNext = true;
		}
		if(hasNext){
		    showRound(lastRound);
		}	    
	    }else{
		lastRound = maxRound - 2;
		hasNext = false;
	    }

	    if(hasNext && !master.stop){
		((Graphics2D) g).drawImage(outPutImage, null, 0 ,0);
	    } 
 
	    if (hasNext && !master.stop) {
		repaint();
	    }

	if(master.oneStep){
	    master.stop = true;
	}

	synchronized(this){
	    try{
		wait(master.slowDown);
	    }catch(Exception e){
	    }
	}

    }
}


class MyActionListener implements ActionListener{
    AntDebugger master;
    MyCanvas canvas = null;

    public MyActionListener(AntDebugger master){
	this.master = master;
    }

    public void setCanvas(MyCanvas m){
	canvas = m;
    }

    public void actionPerformed(ActionEvent e){
	if(e.getActionCommand().equals("Start")){
	    master.oneStep = false;
	    master.stop = false;
	    canvas.repaint();
	}else
	    if(e.getActionCommand().equals("Stop")){
		master.stop = true;		
	    }else
		if(e.getActionCommand().equals("Forward")){
		    master.back = false;
		    canvas.repaint();
		}else
		    if(e.getActionCommand().equals("Back")){
			master.back = true;
			canvas.repaint();
		    }else
			if(e.getActionCommand().equals("OneStep")){
			    master.oneStep = true;
			    master.stop = false;
			    canvas.repaint();
			}
    }
}


/**
 * This class reads in a file with the following format:
 * <full Name of the map file>
 * ...
 */
public class AntDebugger extends WindowAdapter implements Constants, AdjustmentListener{
    public AntWorld world;
    MyActionListener myActionListener;
    public java.util.List rounds = null;
    BufferedReader fileReader = null;
    Window window = null;
    MyCanvas myCanvas = null;

    public boolean stop = false;
    public boolean back = false;
    public boolean oneStep = false;
    public int slowDown = 1;

    public static int options;

    public AntDebugger(){
	myActionListener = new MyActionListener(this);
	rounds = new Vector(1000);
    }
       
    protected void readMap(String fileName) throws Exception{
	//preparation
	FileInputStream fis1 = new FileInputStream(fileName);
	fileReader = new BufferedReader(new InputStreamReader(fis1));
	//read in parameter of file
	String mapName = fileReader.readLine();
	FileInputStream fis2 = new FileInputStream(mapName);
	BufferedReader br = new BufferedReader(new InputStreamReader(fis2));
	int x = (int) new Integer(br.readLine()).intValue();
	int y = (int) new Integer(br.readLine()).intValue();
	world = new AntWorld(x, y, 92);
	for(int i=0;i<x;i++){
	    StringTokenizer st = new StringTokenizer(br.readLine());
	    int j=-1;
	    while(st.hasMoreTokens()){
		j++;
		String s = st.nextToken();
		if(s.compareTo(".") == 0){
		    world.field[i][j].state = FREE;
		    continue;
		}
		if(s.compareTo("#") == 0){
		    world.field[i][j].state = ROCK;
		    continue;
		}
		if(s.compareTo("+") == 0){
		    world.field[i][j].state = RED_ANT_HILL;
		    continue;
		}
		if(s.compareTo("-") == 0){
		    world.field[i][j].state = BLACK_ANT_HILL;
		    continue;
		}
		byte food = (byte) new Byte(s).byteValue();
		world.field[i][j].food = food;
		world.field[i][j].state= FREE; 
	    }
	}
	fis2.close();
	br.close();
    }

    public synchronized void adjustmentValueChanged(AdjustmentEvent e){
	 slowDown = e.getValue();
	 if(slowDown == 0){
	     slowDown = 1;
	 }
	 if(slowDown < 1001){
	     back = true;
	     oneStep = false;
	     stop = false;
	     myCanvas.repaint();	     
	     return;
	 }
	 if(slowDown > 1000){
	     slowDown = 2001 - slowDown ;
	     back = false;     
	 }
	 oneStep = false;
	 stop = false;
	 myCanvas.repaint();
    }

    public void showWorld() throws Exception{
	//Build up the frame with its components
	window = new Frame("The Ant World");
	window.setLayout(new BorderLayout());
	window.addWindowListener(this);
	window.setSize(915, 830);

	myCanvas = new MyCanvas(world, this);
	myActionListener.setCanvas(myCanvas);
	myCanvas.setBackground(Color.WHITE);

	Panel panel = new Panel(new GridLayout(5,1));

	Button start = new Button("Start");
	start.addActionListener(myActionListener);
	Button stop = new Button("Stop");
	stop.addActionListener(myActionListener);
	Button back = new Button("Back");
	back.addActionListener(myActionListener);
	Button forward = new Button("Forward");
	forward.addActionListener(myActionListener);
	Button oneStep = new Button("OneStep");
	oneStep.addActionListener(myActionListener);

	panel.add(start, "1");
	panel.add(stop, "2");
	panel.add(forward,"3");
	panel.add(oneStep,"4");
	panel.add(back, "5");

	Scrollbar scrollBar = new Scrollbar(Scrollbar.VERTICAL, 1000, 25, 1, 2000);
	scrollBar.addAdjustmentListener(this);

	window.add("Center", myCanvas);
	window.add("East", panel);
	window.add("West", scrollBar);

	myCanvas.init();

	window.show();
    }

    public void printWorld(){
	for(int i=0;i<world.field.length;i++){
	    if((i%2) == 1) System.out.print(" ");
	    for(int j=0;j<world.field[i].length;j++){		
		switch(world.field[i][j].state){
		case FREE:{
		    System.out.print(".");
		    break;
		}
		case ROCK:{
		    System.out.print("#" + " ");
		    break;
		}
		case RED_ANT_HILL:{
		    System.out.print("-" + " ");
		    break;
		}
		case BLACK_ANT_HILL:{
		    System.out.print("+" + " ");
		    break;
		}
		default:{
		    System.out.print("?"+ " ");
		}
		}
		if(world.field[i][j].food > 0){
		    System.out.print("5"+ " ");
		}
	    }
	    System.out.println();
	}
	System.out.println();
    }

    public void windowClosing(WindowEvent e){
	System.exit(0);
    }

    public void readAllRounds() throws Exception{
	String line = fileReader.readLine();
	Round round = null;
	while(line != null){
	    StringTokenizer st = new StringTokenizer(line);
	    while(st.hasMoreTokens()){
		String token = st.nextToken();
		if(token.equals("round")){
		    if(round != null){
			rounds.add(round);
		    }
		    round = new Round((int)new Integer(st.nextToken()).intValue());
		    continue;
		}
		if(token.equals("ant")){
		    Ant ant = new Ant();
		    ant.xPos = (byte) new Byte(st.nextToken()).byteValue();
		    ant.yPos = (byte) new Byte(st.nextToken()).byteValue();
		    byte colour = (byte) new Byte(st.nextToken()).byteValue();
		    if(colour == 0){
			ant.state |= RED_ANT;
		    }else
			if(colour == 1){
			    ant.state |= BLACK_ANT;
			}else throw new Error("Wrong colour.");
		    ant.ID = (int) new Integer(st.nextToken()).intValue();
		    ant.direction = (byte) new Byte(st.nextToken()).byteValue();
		    byte food = (byte) new Byte(st.nextToken()).byteValue();
		    if(food == 1){
			ant.state |= WITH_FOOD;
		    }else
			if(food != 0) throw new Error("Wrong food information.");
		    ant.internalState = (int) new Integer(st.nextToken()).intValue();
		    ant.resting = (byte) new Byte(st.nextToken()).byteValue();
		    round.ants.add(ant);
		}else
		    if(token.equals("food")){
			Food food = new Food();
			food.xPos = (int) new Integer(st.nextToken()).intValue();
			food.yPos = (int) new Integer(st.nextToken()).intValue();
			food.howMuch = (int) new Integer(st.nextToken()).intValue();
			round.food.add(food);
		    }else
			if(token.equals("marker")){
			    Marker marker = new Marker();
			    marker.xPos = (int) new Integer(st.nextToken()).intValue();
			    marker.yPos = (int) new Integer(st.nextToken()).intValue();
			    marker.red = (int) new Integer(st.nextToken()).intValue();
			    marker.black = (int) new Integer(st.nextToken()).intValue();
			    round.marker.add(marker);
			}
	    }
	    line = fileReader.readLine();
	}
	fileReader.close();
	rounds.add(round);
    }

    public boolean readOptions(String[] args){
	options = 0;
	if(args.length < 1){
	    usage();
	    return false;
	}
	//pop fileName away
	for(int i=1;i<args.length;i++){
	    if(args[i].equals("-b")){
		options |= OPTION_MARKER_BIT;
	    }else{
		if(args[i].equals("-3C") || args[i].equals("-3c")){
		    options |= OPTION_MARKER_3C;
		}else{
		    if(args[i].equals("-fm")){
			options |= OPTION_MARKER_FM;
		    }else{
			usage();
			return false;
		    }
		}
	    }
	}
	return true;
    }

    public void usage(){
	System.out.println("Usage:");
	System.out.println("AntDebugger <fileName> <options>");
	System.out.println("   <options> ::= <option> <options>");
	System.out.println("   <option>  ::= -b       //to see markers as bitfield");
	System.out.println("               | -3C      //to see 3 different marker colors");
	System.out.println("               | -fm      //food marker");	
	System.out.println("               & -h       //this");
    }

    public static void main(String[] args) throws Exception{	
	AntDebugger self = new AntDebugger();
	//the first argument is the fileName
	if(!self.readOptions(args)){
	    return;
	}
	self.readMap(args[0]);
	
	self.readAllRounds();

	//For debugging
	//self.printWorld();

	//Show world
	self.showWorld();

	//	self.myCanvas.repaint();
    }

}
