#!/bin/bash

# ANT Simulation Programm
#
# ----------------------------------------------------------------------
# 
# (c) by the ICFP 2004 Team "KaNT"
#
# Jens Hauke <hauke@ipd.uka.de>
# Thomas Moschny <moschny@ipd.uka.de>
# Bernhard Haumacher <haui@haumacher.de>
# Bjoern Hartmann <bjoern@derhartmann.de>
#
# ----------------------------------------------------------------------
# 
# This is free software (GPL).
# 
# $Rev: 1519 $
# $Date: 2004-06-05 15:46:19 +0200 (Sat, 05 Jun 2004) $
#
# Compare all ant programs in the cwd and print a ranking to stdout
# *jh*

bindir=$(dirname $0)
antsim=${bindir}/antsim
world=${1?"arg1 must be the world!"}
#${bindir}/../../map/sample7.world
result=contest.result.$(basename $world)

if test -f $result;then
  echo "$result already exists"
  exit 1
fi

function allstat() {
	echo "######################################"
	cat $result|gawk '
	{
            if ($1 != "#") {
		if ($3 > $4) {
			win[$1]++;
			win[$2]+=0;
			loose[$2]++;
			loose[$1]+=0;
		} else {
			win[$1]+=0;
			win[$2]++;
			loose[$1]++;
			loose[$2]+=0;
		}
            }
	}
	
	END{
		for(i in win) {
			print win[i], loose[i], i;
		}
	}
'|sort -n
}

echo "# Using world $world"|tee -a $result

ls *|grep -v contest.result.| gawk '
BEGIN{mapcnt=0;}

{map[mapcnt]=$1;mapcnt++;}

END{
  	for (i=0;i<mapcnt;i++){
		for(j=i+1;j<mapcnt;j++){
			print map[i],map[j];
   		}
	}
}
'| while read a b; do
	echo $a $b $(${antsim} -1 $a -2 $b -w ${world} )|tee -a $result
	allstat
done
echo "# Using world $world"|tee -a $result
	
allstat|tee -a $result
