/*
 * ANT Simulation Programm
 *
 * ----------------------------------------------------------------------
 * 
 * (c) by the ICFP 2004 Team "KaNT"
 *
 * Jens Hauke <hauke@ipd.uka.de>
 * Thomas Moschny <moschny@ipd.uka.de>
 * Bernhard Haumacher <haui@haumacher.de>
 * Bjoern Hartmann <bjoern@derhartmann.de>
 *
 * ----------------------------------------------------------------------
 * 
 * This is free software (GPL).
 * 
 * $Rev: 1519 $
 * $Date: 2004-06-05 15:46:19 +0200 (Sat, 05 Jun 2004) $
 *
 * Tests the random number generator.
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <math.h>

static inline
int next_s(int s)
{
    return s*22695477+1;
}

static unsigned int random_cur;

static
void randomseed(int seed)
{
    random_cur = next_s(next_s(next_s(seed)));
}

static
int randomint(int n)
{
    random_cur = next_s(random_cur);
    return ((random_cur / 65536) % 16384) % n;
}


int main(int argc, char **argv)
{
    int i;

    randomseed(12345);
    
    for (i = 0; i < 100; i++) {
	printf("%d \n", randomint(65536));
    }
    
    return 0;
}


/*
 * Local Variables:
 *  compile-command: "gcc randomtest.c -Wall -W -Wno-unused -O2 -o randomtest && randomtest"
 * End:
 *
 */
